#tag Class
Protected Class movie_playlist_mgr
	#tag Method, Flags = &h0
		Sub Constructor(Database_str As String)
		  
		  ' Get folder item for database file.
		  '
		  Var Database_fi As FolderItem = New FolderItem(Database_str, FolderItem.PathModes.Native)
		  If (Database_fi = Nil) Or (Database_fi.IsFolder = True) Or (Database_fi.Exists = False) Then
		    Var AckBox_obj As ack_box = New ack_box
		    Var Message_str As String
		    Message_str = Message_str + "File does not exist." + EndOfLine
		    Message_str = Message_str + Database_str
		    AckBox_obj.ShowModal("SQLite Database", Message_str, ack_box.MsgTypes.Emergency)
		    Quit
		  End If
		  
		  ' Create instance of the SQLite database object.
		  '
		  SQLite_pdb = New SQLiteDatabase(Database_fi)
		  
		  ' Attempt to connect database engine with the database file.
		  '
		  Try
		    SQLite_pdb.Connect
		    
		  Catch Error As IOException
		    Var AckBox_obj As ack_box = New ack_box
		    Var Message_str As String
		    Message_str = Message_str + "Couldn't connect to the SQLite database." + EndOfLine
		    Message_str = Message_str + "Error #" + Error.ErrorNumber.ToString + " : " + LinuxSysErrorLookup(Error.ErrorNumber)
		    AckBox_obj.ShowModal("SQLite Database", Message_str, ack_box.MsgTypes.Emergency)
		    Quit
		  End Try
		  
		  ' Invoke the query with no parameters to retrieve all records.
		  '
		  Query
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Destroy instance of the SQLite recordset object.
		  '
		  IDs_prs = Nil
		  
		  ' Destroy instance of the SQLite database object.
		  '
		  SQLite_pdb = Nil
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub GetMediaInfo(ID_int As Integer)
		  
		  Var SQL_str As String
		  
		  
		  ' Create query.
		  '
		  SQL_str = "SELECT File, MovieArt, MovieName, MovieTagline FROM MovieFiles WHERE ID=" + ID_int.ToText
		  
		  
		  ' Execute query.
		  '
		  MediaInfo_prs = SQLite_pdb.SelectSQL(SQL_str)
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaArt() As Picture
		  
		  Var MediaArt_pic As Picture = Nil
		  
		  
		  If IDs_pint.LastIndex > -1 Then
		    GetMediaInfo(IDs_pint(Ptr_pint))
		    MediaArt_pic = MediaInfo_prs.Column("MovieArt").PictureValue
		  Else
		    MediaArt_pic = Nil
		  End If
		  
		  Return MediaArt_pic
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaCount() As Integer
		  
		  Return IDs_pint.LastIndex + 1
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaFile() As String
		  
		  Var MediaFile_str As String
		  
		  
		  If IDs_pint.LastIndex > -1 Then
		    GetMediaInfo(IDs_pint(Ptr_pint))
		    MediaFile_str = MediaInfo_prs.Column("File").StringValue
		  Else
		    MediaFile_str = ""
		  End If
		  
		  Return MediaFile_str
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaPointer() As Integer
		  
		  Return Ptr_pint + 1
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MediaPointer(Assigns NewValue_int As Integer)
		  
		  Ptr_pint = NewValue_int - 1
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function MediaText() As String
		  
		  Var MediaText_str As String
		  
		  
		  If IDs_pint.LastIndex > -1 Then
		    
		    GetMediaInfo(IDs_pint(Ptr_pint))
		    
		    MediaText_str _
		    = MediaInfo_prs.Column("MovieName").StringValue + EndOfLine _
		    + MediaInfo_prs.Column("MovieTagline").StringValue
		    
		    MediaText_str = ReplaceAll(MediaText_str, "&", "&&")
		    
		  Else
		    
		    MediaText_str = ""
		    
		  End If
		  
		  Return MediaText_str
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MoveNext()
		  
		  ' Do we have any media items to traverse?
		  '
		  If IDs_pint.LastIndex = -1 Then
		    Exit Sub
		  End If
		  
		  ' Increment pointer.
		  '
		  Ptr_pint = Ptr_pint + 1
		  
		  ' Out of bounds check.
		  '
		  If Ptr_pint > IDs_pint.LastIndex Then
		    
		    ' Is repeat flag set?
		    '
		    If Repeat_pboo = True Then
		      Ptr_pint = 0
		    Else
		      Ptr_pint = IDs_pint.LastIndex
		    End If
		    
		  End If
		  
		  ' Get media info.
		  '
		  GetMediaInfo(IDs_pint(Ptr_pint))
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub MovePrevious()
		  
		  ' Do we have any media items to traverse?
		  '
		  If IDs_pint.LastIndex = -1 Then
		    Exit Sub
		  End If
		  
		  ' Decrement pointer.
		  '
		  Ptr_pint = Ptr_pint - 1
		  
		  ' Out of bounds check.
		  '
		  If Ptr_pint < 0 Then
		    
		    ' Is repeat flag set?
		    '
		    If Repeat_pboo = True Then
		      Ptr_pint = IDs_pint.LastIndex
		    Else
		      Ptr_pint = 0
		    End If
		    
		  End If
		  
		  ' Get media info.
		  '
		  GetMediaInfo(IDs_pint(Ptr_pint))
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub PopulateIDArray()
		  
		  ' Purge the IDs array.
		  '
		  IDs_pint.RemoveAll
		  
		  ' Move to first record.
		  '
		  IDs_prs.MoveToFirstRow
		  
		  ' Populate the IDs array.
		  '
		  Do Until IDs_prs.AfterLastRow = True
		    IDs_pint.Add(IDs_prs.Column("ID").IntegerValue)
		    IDs_prs.MoveToNextRow
		  Loop
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Query(SQLClause_str As String = "")
		  
		  Var SQL_str As String
		  
		  
		  ' User is issuing a new query. This means that we must execute the query,
		  ' populate the ID array, shuffle the array if needed, reset the array
		  ' pointer to zero and fetch the media info for the first array item.
		  
		  ' Define base query to gather IDs.
		  '
		  SQL_str = "SELECT ID FROM MovieFiles"
		  
		  ' Execute the query with SQL clause if provided.
		  '
		  IDs_prs = SQLite_pdb.SelectSQL(SQL_str + " " + SQLClause_str)
		  
		  PopulateIDArray
		  
		  If Shuffle_pboo = True Then
		    IDs_pint.Shuffle
		  End If
		  
		  Ptr_pint = 0
		  
		  If IDs_pint.LastIndex > -1 Then
		    GetMediaInfo(IDs_pint(Ptr_pint))
		  End If
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Repeat() As Boolean
		  
		  Return Repeat_pboo
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Repeat(Assigns NewValue_boo As Boolean)
		  
		  ' Set repeat mode flag.
		  '
		  Repeat_pboo = NewValue_boo
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Function Shuffle() As Boolean
		  
		  Return Shuffle_pboo
		  
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Shuffle(Assigns NewValue_boo As Boolean)
		  
		  ' Set shuffle mode flag.
		  '
		  Shuffle_pboo = NewValue_boo
		  
		  ' Is there anything to shuffle or unshuffle?
		  '
		  If IDs_pint.LastIndex = -1 Then
		    Exit Sub
		  End If
		  
		  Select Case Shuffle_pboo
		    
		  Case True
		    
		    ' Shuffle the IDs array.
		    '
		    IDs_pint.Shuffle
		    
		    GetMediaInfo(IDs_pint(Ptr_pint))
		    
		  Case False
		    
		    ' Unshuffle (rebuild the IDs Array).
		    '
		    PopulateIDArray
		    
		    GetMediaInfo(IDs_pint(Ptr_pint))
		    
		  End Select
		  
		End Sub
	#tag EndMethod


	#tag Note, Name = ReadMe
		
		The MoviePlaylistManager class is the interface layer between the client GUI and the underlying movie files
		cataloged in the SQLite database. Playlists are defined by SQL queries. This means that a playlist will
		autmatically include any new MP3 files that match the SQL query.
		
		All media files (MP4 movie) are stored in a SQLite table named "MovieFiles". The table contains meta-data
		about each MP4 file such as:
		
		ID:
		Unique numeric ID of each MP4 file in table. When the class is instantiated, it executes a default query
		that retrieves a recordset consisting of the ID for each file in the table and stores these IDs in an array.
		The array is used as the playlist and can be traversed forward and backward, and each ID used to retrieve
		the associated meta-data for a specific MP4 file. When the user turns Shuffle ON, the array is shuffled in
		which case the playlist then presents the ID's in a random order. The recordset is not discarded after it
		is used to build the array, instead it is kept in the event that the array needs to be rebuilt such as when
		the user decides to turn Shuffle OFF and the array must then be rebuilt in the same order as the recordset.
		
		File:
		The fully qualified name of the MP4 file. This handed to the OMXPlayer to play the MP4 file.
		
		LastModified:
		The date and time the MP4 file was last modified. (A syncing routine is needed to update the Music table
		with new or modified MP4 files and to delete records for MP4 files that are no longer in the media folder.
		When syncing the database to the MP4 folder, this date and time can be used to determine if the database
		record needs to be updated.
		
		MovieArt:
		A binary large object "BLOB" field that holds the artwork for the MP4 file.
		
		MovieName:
		Identifies by name the MP4 file.
		
		MovieYear:
		The year the movie was released.
		
		MovieGenre:
		Text describing the genre of the MP4 file.
		
	#tag EndNote


	#tag Property, Flags = &h21
		Private IDs_pint() As Integer
	#tag EndProperty

	#tag Property, Flags = &h21
		Private IDs_prs As RowSet = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private MediaInfo_prs As RowSet = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Ptr_pint As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Repeat_pboo As Boolean = False
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shuffle_pboo As Boolean = False
	#tag EndProperty

	#tag Property, Flags = &h21
		Private SQLite_pdb As SQLiteDatabase = Nil
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
