#tag Class
Protected Class comvette
Inherits Application
	#tag Event
		Sub Close()
		  
		  ' Save configuration.
		  '
		  ConfigSave
		  
		  ' Destroy main window.
		  '
		  MainWindow_gobj = Nil
		  
		  ' Destroy the global instance of the Audio Switch Manager class.
		  '
		  AudioSwitchMgr_gobj = Nil
		  
		  ' Destroy the global instance of the Antenna Manager class.
		  '
		  AntennaMgr_gobj = Nil
		  
		  ' Destroy the global instance of the Amplifier Manager class.
		  '
		  AmplifierMgr_gobj = Nil
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		  ' Get path to our executable
		  '
		  AppPath_gstr = App.ExecutableFile.Parent.NativePath
		  
		  ' Get our executable file name
		  '
		  AppName_gstr = App.ExecutableFile.Name
		  
		  ' Get folder item for INI file
		  '
		  INIFile_gfi = New FolderItem(AppPath_gstr + AppName_gstr + ".ini", FolderItem.PathModes.Native)
		  
		  ' Load configuration
		  '
		  ConfigLoad
		  
		  ' Initialize the GPIO system.
		  '
		  GPIO.SetupGPIO
		  
		  ' Set the piezo beeper GPIO pin to act as an output.
		  '
		  GPIO.PinMode(ConfigPinBeeper_gint, GPIO.OUTPUT)
		  
		  ' Create a global instance of the Audio Switch Manager class.
		  '
		  AudioSwitchMgr_gobj = New audio_switch_mgr
		  
		  ' Create a global instance of the Antenna Manager class.
		  '
		  AntennaMgr_gobj = New antenna_mgr
		  
		  ' Create a global instance of the Amplifier Manager class.
		  '
		  AmplifierMgr_gobj = New amplifier_mgr
		  
		  ' Set the mouse cursor.
		  '
		  Select Case ConfigMouseCursor_gstr
		  Case "show"
		    App.MouseCursor = Nil
		  Case "hide"
		    App.MouseCursor = System.Cursors.InvisibleCursor
		  End Select
		  
		  ' Create main window.
		  '
		  MainWindow_gobj = New main_window
		  
		  ' Display main window.
		  '
		  MainWindow_gobj.Show
		  
		End Sub
	#tag EndEvent

	#tag Event
		Function UnhandledException(error As RuntimeException) As Boolean
		  
		  LogErrorAndQuit(error)
		  
		End Function
	#tag EndEvent


	#tag Note, Name = Notice
		This file is part of Comvette.
		
		Comvette is free software: you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation, either version 3 of the License, or
		(at your option) any later version.
		
		Comvette is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with Comvette. If not, see <https://www.gnu.org/licenses/>.
		
	#tag EndNote

	#tag Note, Name = ReadMe
		The Comvette program is an integral part of a larger project outlined on my
		website:
		
		  https://www.comvette.com
		
		I wanted to create an infotainment system for my classic 4th generation
		(1984-1989) Corvette which would replace the aging in-dash BOSE AM/FM/Cassette
		stereo with something more modern. Comvette is the result of my efforts.
		
		I am open sourcing the software under the GNU GPL in the hopes that others
		will find it useful and possibly contribute to its further development.
		
		Comvette is an evolving project so check in once in a while to see the latest
		developments.
		
		If you have comments, questions or suggestions you can contact me at:
		
		  wes@westhaver.com
		
		Comvette is Copyright 2017-2021 Lawrence Westhaver.
		
	#tag EndNote


	#tag ViewBehavior
	#tag EndViewBehavior
End Class
#tag EndClass
