#tag Window
Begin ContainerControl digital_clock
   AcceptFocus     =   False
   AcceptTabs      =   True
   AutoDeactivate  =   True
   BackColor       =   &cFFFFFF00
   Backdrop        =   0
   DoubleBuffer    =   False
   Enabled         =   True
   EraseBackground =   False
   HasBackColor    =   False
   Height          =   55
   HelpTag         =   ""
   InitialParent   =   ""
   Left            =   0
   LockBottom      =   False
   LockLeft        =   False
   LockRight       =   True
   LockTop         =   True
   TabIndex        =   0
   TabPanelIndex   =   0
   TabStop         =   False
   Top             =   0
   Transparent     =   True
   UseFocusRing    =   False
   Visible         =   True
   Width           =   225
   Begin Canvas DigitalClock_cnvs
      AcceptFocus     =   False
      AcceptTabs      =   False
      AutoDeactivate  =   True
      Backdrop        =   0
      DoubleBuffer    =   True
      Enabled         =   True
      Height          =   55
      HelpTag         =   ""
      Index           =   -2147483648
      InitialParent   =   ""
      Left            =   0
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      Scope           =   2
      TabIndex        =   2
      TabPanelIndex   =   0
      TabStop         =   True
      Top             =   0
      Transparent     =   True
      UseFocusRing    =   False
      Visible         =   True
      Width           =   225
   End
   Begin Timer DigitalClock_tmr
      Index           =   -2147483648
      LockedInPosition=   True
      Mode            =   2
      Period          =   1000
      Scope           =   2
      TabPanelIndex   =   0
   End
End
#tag EndWindow

#tag WindowCode
#tag EndWindowCode

#tag Events DigitalClock_cnvs
	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  
		  #Pragma Unused areas
		  
		  Var Now_dat As DateTime = DateTime.Now
		  Var Hour_int As Integer
		  Var Minute_int As Integer
		  Var Second_int As Integer
		  Var AMPM_int As Integer
		  
		  Var HourDigit1_int As Integer
		  Var HourDigit2_int As Integer
		  Var ColonState_int As Integer
		  Var MinuteDigit1_int As Integer
		  Var MinuteDigit2_int As Integer
		  
		  
		  ' Get component parts of now.
		  '
		  Hour_int = Now_dat.Hour
		  Minute_int = Now_dat.Minute
		  Second_int = Now_dat.Second
		  
		  ' Get AM or PM and colon state.
		  '
		  AMPM_int = Hour_int \ 12
		  ColonState_int = Second_int Mod 2
		  
		  ' Break hour into individual values.
		  '
		  HourDigit1_int = (Hour_int Mod 12) \ 10
		  HourDigit2_int = (Hour_int Mod 12) Mod 10
		  
		  ' Break minute into individual values.
		  '
		  MinuteDigit1_int = Minute_int \ 10
		  MinuteDigit2_int = Minute_int Mod 10
		  
		  ' Define character Dimensions of characters in bit map.
		  '
		  Const CharWidth = 30
		  Const CharHeight = 55
		  
		  ' Define offsets for each character in bit map.
		  '
		  Const Digit_0   = CharWidth * 0
		  Const Digit_1   = CharWidth * 1
		  Const Digit_2   = CharWidth * 2
		  Const Digit_3   = CharWidth * 3
		  Const Digit_4   = CharWidth * 4
		  Const Digit_5   = CharWidth * 5
		  Const Digit_6   = CharWidth * 6
		  Const Digit_7   = CharWidth * 7
		  Const Digit_8   = CharWidth * 8
		  Const Digit_9   = CharWidth * 9
		  Const Digit_OFF = CharWidth * 10
		  Const Colon_ON  = CharWidth * 11
		  Const Colon_OFF = CharWidth * 12
		  Const AMPM_AM   = CharWidth * 13
		  Const AMPM_PM   = CharWidth * 14
		  
		  ' DrawPicture(Source, DestX, DestY, DestWidth, DestHeight, SourceX, SourceY, SourceWidth, SourceHeight)
		  
		  ' Draw first digit of 'hour' if non-zero.
		  '
		  If (HourDigit1_int = 0) And (HourDigit2_int = 0) Then
		    g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, Digit_1, 0, CharWidth, CharHeight)
		  Else
		    If (HourDigit1_int = 0) Then
		      g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, Digit_OFF, 0, CharWidth, CharHeight)
		    Else
		      g.DrawPicture(digital_clock_palette, 0, 0, CharWidth, CharHeight, CharWidth * HourDigit1_int, 0, CharWidth, CharHeight)
		    End If
		  End If
		  
		  ' Draw second digit of 'hour'.
		  '
		  If (HourDigit1_int = 0) And (HourDigit2_int = 0) Then
		    g.DrawPicture(digital_clock_palette, 45, 0, CharWidth, CharHeight, Digit_2, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 45, 0, CharWidth, CharHeight, CharWidth * HourDigit2_int, 0, CharWidth, CharHeight)
		  End If
		  
		  ' Draw colon either on or off.
		  ' 
		  If ColonState_int = 0 Then
		    g.DrawPicture(digital_clock_palette, 75, 0, CharWidth, CharHeight, Colon_OFF, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 75, 0, CharWidth, CharHeight, Colon_ON, 0, CharWidth, CharHeight)
		  End If
		  
		  ' Draw first digit of 'minute'.
		  ' 
		  g.DrawPicture(digital_clock_palette, 105, 0, CharWidth, CharHeight, CharWidth * MinuteDigit1_int, 0, CharWidth, CharHeight)
		  
		  ' Draw second digit of 'minute'.
		  ' 
		  g.DrawPicture(digital_clock_palette, 150, 0, CharWidth, CharHeight, CharWidth * MinuteDigit2_int, 0, CharWidth, CharHeight)
		  
		  ' Draw AM/PM indicator.
		  '
		  If AMPM_int = 0 Then
		    g.DrawPicture(digital_clock_palette, 195, 0, CharWidth, CharHeight, AMPM_AM, 0, CharWidth, CharHeight)
		  Else
		    g.DrawPicture(digital_clock_palette, 195, 0, CharWidth, CharHeight, AMPM_PM, 0, CharWidth, CharHeight)
		  End If
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag Events DigitalClock_tmr
	#tag Event
		Sub Action()
		  
		  DigitalClock_cnvs.Invalidate
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag ViewBehavior
	#tag ViewProperty
		Name="AllowAutoDeactivate"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Tooltip"
		Visible=true
		Group="Appearance"
		InitialValue=""
		Type="String"
		EditorType="MultiLineEditor"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocusRing"
		Visible=true
		Group="Appearance"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
		EditorType="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocus"
		Visible=true
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowTabs"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="DoubleBuffer"
		Visible=true
		Group="Windows Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		InitialValue=""
		Type="Picture"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Enabled"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="EraseBackground"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="InitialParent"
		Visible=false
		Group="Position"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Left"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockBottom"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockLeft"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockRight"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockTop"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabIndex"
		Visible=true
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabPanelIndex"
		Visible=false
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabStop"
		Visible=true
		Group="Position"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Top"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Transparent"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
#tag EndViewBehavior
