#tag Window
Begin ContainerControl digital_frequency_display
   AcceptFocus     =   False
   AcceptTabs      =   True
   AutoDeactivate  =   True
   BackColor       =   &cFFFFFF00
   Backdrop        =   0
   DoubleBuffer    =   False
   Enabled         =   True
   EraseBackground =   False
   HasBackColor    =   False
   Height          =   110
   HelpTag         =   ""
   InitialParent   =   ""
   Left            =   0
   LockBottom      =   False
   LockLeft        =   False
   LockRight       =   True
   LockTop         =   True
   TabIndex        =   0
   TabPanelIndex   =   0
   TabStop         =   False
   Top             =   0
   Transparent     =   True
   UseFocusRing    =   False
   Visible         =   True
   Width           =   360
   Begin Canvas DigitalFrequency_cnvs
      AcceptFocus     =   False
      AcceptTabs      =   False
      AutoDeactivate  =   True
      Backdrop        =   0
      DoubleBuffer    =   True
      Enabled         =   True
      Height          =   110
      HelpTag         =   ""
      Index           =   -2147483648
      InitialParent   =   ""
      Left            =   0
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      Scope           =   2
      TabIndex        =   2
      TabPanelIndex   =   0
      TabStop         =   True
      Top             =   0
      Transparent     =   True
      UseFocusRing    =   False
      Visible         =   True
      Width           =   360
   End
End
#tag EndWindow

#tag WindowCode
	#tag Method, Flags = &h0
		Sub Update(Frequency_int As UInt32)
		  
		  Frequency_psgl = Frequency_int / 1000000
		  
		  DigitalFrequency_cnvs.Invalidate
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private Frequency_psgl As Single
	#tag EndProperty


#tag EndWindowCode

#tag Events DigitalFrequency_cnvs
	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  
		  #Pragma Unused areas
		  
		  Var Frequency_str As String
		  Var DigitValue_int As Integer
		  
		  Const CHAR_WIDTH = 60
		  Const CHAR_HEIGHT = 110
		  Const DIM_DIGIT = 10
		  Const LIT_DOT = 11
		  
		  
		  ' Get formatted string version of frequency.
		  '
		  Frequency_str = Format(Frequency_psgl, "000.0")
		  
		  ' DrawPicture(Source, DestX, DestY, DestWidth, DestHeight, SourceX, SourceY, SourceWidth, SourceHeight)
		  
		  ' Draw first digit of frequency.
		  '
		  DigitValue_int = Val(Frequency_str.Middle(0, 1))
		  If DigitValue_int = 0 Then
		    g.DrawPicture(digital_radio_palette,   0, 0, CHAR_WIDTH, CHAR_HEIGHT, DIM_DIGIT * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  Else
		    g.DrawPicture(digital_radio_palette,   0, 0, CHAR_WIDTH, CHAR_HEIGHT, DigitValue_int * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  End If
		  
		  ' Draw second digit of frequency.
		  '
		  DigitValue_int = Val(Frequency_str.Middle(1, 1))
		  g.DrawPicture(digital_radio_palette,  90, 0, CHAR_WIDTH, CHAR_HEIGHT, DigitValue_int * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  
		  ' Draw third digit of frequency.
		  '
		  DigitValue_int = Val(Frequency_str.Middle(2, 1))
		  g.DrawPicture(digital_radio_palette, 180, 0, CHAR_WIDTH, CHAR_HEIGHT, DigitValue_int * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  
		  ' Draw decimal point.
		  ' 
		  g.DrawPicture(digital_radio_palette, 240, 0, CHAR_WIDTH, CHAR_HEIGHT,  LIT_DOT * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  
		  ' Draw last digit of frequency.
		  ' 
		  DigitValue_int = Val(Frequency_str.Middle(4, 1))
		  g.DrawPicture(digital_radio_palette, 300, 0, CHAR_WIDTH, CHAR_HEIGHT, DigitValue_int * CHAR_WIDTH, 0, CHAR_WIDTH, CHAR_HEIGHT)
		  
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag ViewBehavior
	#tag ViewProperty
		Name="AllowAutoDeactivate"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Tooltip"
		Visible=true
		Group="Appearance"
		InitialValue=""
		Type="String"
		EditorType="MultiLineEditor"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocusRing"
		Visible=true
		Group="Appearance"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
		EditorType="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocus"
		Visible=true
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowTabs"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="DoubleBuffer"
		Visible=true
		Group="Windows Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		InitialValue=""
		Type="Picture"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Enabled"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="EraseBackground"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="InitialParent"
		Visible=false
		Group="Position"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Left"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockBottom"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockLeft"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockRight"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockTop"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabIndex"
		Visible=true
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabPanelIndex"
		Visible=false
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabStop"
		Visible=true
		Group="Position"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Top"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Transparent"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
#tag EndViewBehavior
