#tag Window
Begin ContainerControl obd_viewer_gui
   AcceptFocus     =   False
   AcceptTabs      =   True
   AutoDeactivate  =   True
   BackColor       =   &cFFFFFF00
   Backdrop        =   1106249727
   DoubleBuffer    =   False
   Enabled         =   True
   EraseBackground =   True
   HasBackColor    =   False
   Height          =   360
   HelpTag         =   ""
   InitialParent   =   ""
   Left            =   0
   LockBottom      =   False
   LockLeft        =   False
   LockRight       =   False
   LockTop         =   False
   TabIndex        =   0
   TabPanelIndex   =   0
   TabStop         =   True
   Top             =   0
   Transparent     =   True
   UseFocusRing    =   False
   Visible         =   True
   Width           =   510
   Begin single_action_button Power_btn
      AcceptFocus     =   True
      AcceptTabs      =   False
      AutoDeactivate  =   True
      Backdrop        =   0
      Caption         =   ""
      CaptionColor    =   &cFFFFFF00
      CaptionOffset   =   0
      Clip            =   False
      DoubleBuffer    =   False
      Enabled         =   True
      FontSize        =   22
      Height          =   75
      HelpTag         =   ""
      Icon            =   681740287
      IconOffset      =   0
      Index           =   -2147483648
      InitialParent   =   ""
      Left            =   0
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      Scope           =   2
      TabIndex        =   1
      TabPanelIndex   =   0
      TabStop         =   True
      Top             =   285
      Transparent     =   False
      UseFocusRing    =   False
      Visible         =   True
      Width           =   142
   End
   Begin Label OBDData_lbl
      AutoDeactivate  =   True
      Bold            =   False
      DataField       =   ""
      DataSource      =   ""
      Enabled         =   True
      Height          =   233
      HelpTag         =   ""
      Index           =   -2147483648
      InitialParent   =   ""
      Italic          =   False
      Left            =   20
      LockBottom      =   False
      LockedInPosition=   True
      LockLeft        =   True
      LockRight       =   False
      LockTop         =   True
      Multiline       =   True
      Scope           =   2
      Selectable      =   False
      TabIndex        =   2
      TabPanelIndex   =   0
      TabStop         =   True
      Text            =   ""
      TextAlign       =   0
      TextColor       =   &cFFFFFF00
      TextFont        =   "Courier"
      TextSize        =   16.0
      TextUnit        =   1
      Top             =   20
      Transparent     =   True
      Underline       =   False
      Visible         =   True
      Width           =   470
   End
End
#tag EndWindow

#tag WindowCode
	#tag Event
		Sub Close()
		  
		  OBDDevice_psrlcn.Close
		  
		  Buffer_pstr = ""
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  
		  #Pragma Unused areas
		  
		  
		  DrawDecorativeFrame(g, "large")
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h0
		Sub Constructor()
		  
		  ' Create serial communications object
		  '
		  OBDDevice_psrlcn = New SerialConnection
		  
		  ' Add event handlers
		  '
		  AddHandler OBDDevice_psrlcn.DataReceived, WeakAddressOf Self.DataReceivedHandler
		  AddHandler OBDDevice_psrlcn.Error, WeakAddressOf Self.SerialErrorHandler
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub DataReceivedHandler(This_srlcn As SerialConnection)
		  
		  Var OBDData_str As String
		  Var CRLFPosition_int As Integer
		  
		  ' Retreive any waiting data.
		  ' 
		  Buffer_pstr = Buffer_pstr + This_srlcn.ReadAll(Encodings.ASCII)
		  
		  ' Get position of carriage return + line feed (end of message marker).
		  '
		  CRLFPosition_int = Buffer_pstr.IndexOfBytes(Chr(13) + Chr(10))
		  
		  ' Was end of message marker found?
		  ' 
		  If CRLFPosition_int = -1 Then Exit Sub
		  
		  ' Copy OBD message.
		  '
		  OBDData_str = Buffer_pstr.LeftBytes(CRLFPosition_int + 1)
		  OBDData_str = OBDData_str.Trim
		  
		  ' Delete OBD message from buffer.
		  '
		  Buffer_pstr = Buffer_pstr.MiddleBytes(CRLFPosition_int + 1)
		  
		  ' Check for beginning and end of message markers.
		  '
		  If (OBDData_str.LeftBytes(9) <> "111111111") Then
		    Exit Sub
		  End If
		  
		  ' Display OBD bit string.
		  ' 
		  OBDData_lbl.Text = OBDData_str
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Sub Destructor()
		  
		  ' Remove event handlers
		  '
		  RemoveHandler OBDDevice_psrlcn.Error, WeakAddressOf Self.SerialErrorHandler
		  RemoveHandler OBDDevice_psrlcn.DataReceived, WeakAddressOf Self.DataReceivedHandler
		  
		  ' Destroy serial communications object
		  '
		  OBDDevice_psrlcn = Nil 
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub SerialErrorHandler(This_srlcn As SerialConnection, e As RuntimeException)
		  
		  #Pragma Unused This_srlcn
		  
		  Var AckBox_obj As ack_box = New ack_box
		  Var Message_str As String
		  
		  
		  Message_str = Message_str + "While attempting to access the OBD:" + EndOfLine
		  Message_str = Message_str + "A serial port error occurred." + EndOfLine
		  Message_str = Message_str + "Error #" + Str(e.ErrorNumber) + " : " + LinuxSysErrorLookup(e.ErrorNumber)
		  AckBox_obj.ShowModal("Serial Error", Message_str, ack_box.MsgTypes.Warning)
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private Buffer_pstr As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private OBDDevice_psrlcn As SerialConnection = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private PowerState_penu As PowerStates = PowerStates.OFF
	#tag EndProperty


	#tag Enum, Name = PowerStates, Flags = &h0
		OFF
		ON
	#tag EndEnum


#tag EndWindowCode

#tag Events Power_btn
	#tag Event
		Function MouseDown(X_int As Integer, Y_int As Integer) As Boolean
		  
		  #Pragma Unused X_int
		  #Pragma Unused Y_int
		  
		  
		  Return True
		  
		End Function
	#tag EndEvent
	#tag Event
		Sub MouseUp(X_int As Integer, Y_int As Integer)
		  
		  #Pragma Unused X_int
		  #Pragma Unused Y_int
		  
		  
		  Select Case PowerState_penu
		    
		  Case PowerStates.OFF
		    
		    ' Hilite button icon.
		    '
		    Me.Icon = New Picture(icon_power_hilite_32.Width, icon_power_hilite_32.Height)
		    Me.Icon.Graphics.DrawPicture(icon_power_hilite_32, 0, 0)
		    Me.Refresh
		    
		    PowerState_penu = PowerStates.ON
		    
		    Buffer_pstr = ""
		    
		    OBDDevice_psrlcn.Device  = SerialDevice.WithName(ConfigOBDDevice_gstr)
		    OBDDevice_psrlcn.Baud    = SerialConnection.Baud115200
		    OBDDevice_psrlcn.Bits    = SerialConnection.Bits8
		    OBDDevice_psrlcn.Parity  = SerialConnection.Parities.None
		    OBDDevice_psrlcn.StopBit = SerialConnection.StopBits.One
		    OBDDevice_psrlcn.XON     = False
		    OBDDevice_psrlcn.CTS     = False
		    OBDDevice_psrlcn.DTR     = False
		    
		    Try 
		      OBDDevice_psrlcn.Connect
		      
		    Catch Error As IOException
		      Var AckBox_obj As ack_box = New ack_box
		      Var Message_str As String
		      Message_str = Message_str + "Could not connect to the OBD device." + EndOfLine
		      Message_str = Message_str + "Error #" + Error.ErrorNumber.ToString + " : " + LinuxSysErrorLookup(Error.ErrorNumber)
		      AckBox_obj.ShowModal("OBD Device", Message_str, ack_box.MsgTypes.Warning)
		      
		    End Try
		    
		  Case PowerStates.ON
		    
		    ' Lolite button icon.
		    '
		    Me.Icon = New Picture(icon_power_lolite_32.Width, icon_power_lolite_32.Height)
		    Me.Icon.Graphics.DrawPicture(icon_power_lolite_32, 0, 0)
		    Me.Refresh
		    
		    PowerState_penu = PowerStates.OFF
		    
		    OBDDevice_psrlcn.Close
		    
		    Buffer_pstr = ""
		    
		  End Select
		  
		End Sub
	#tag EndEvent
#tag EndEvents
#tag Events OBDData_lbl
	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  #Pragma Unused X
		  #Pragma Unused Y
		  
		  
		  OBDData_lbl.Text = ""
		  
		End Function
	#tag EndEvent
#tag EndEvents
#tag ViewBehavior
	#tag ViewProperty
		Name="AllowAutoDeactivate"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Tooltip"
		Visible=true
		Group="Appearance"
		InitialValue=""
		Type="String"
		EditorType="MultiLineEditor"
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocusRing"
		Visible=true
		Group="Appearance"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
		EditorType="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowFocus"
		Visible=true
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="AllowTabs"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="DoubleBuffer"
		Visible=true
		Group="Windows Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		InitialValue=""
		Type="Picture"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Enabled"
		Visible=true
		Group="Appearance"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="EraseBackground"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="InitialParent"
		Visible=false
		Group="Position"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Left"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockBottom"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockLeft"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockRight"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="LockTop"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabIndex"
		Visible=true
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabPanelIndex"
		Visible=false
		Group="Position"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="TabStop"
		Visible=true
		Group="Position"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Top"
		Visible=true
		Group="Position"
		InitialValue=""
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Transparent"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=false
		Group="Behavior"
		InitialValue=""
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="300"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
#tag EndViewBehavior
