#tag Class
Protected Class base_button
Inherits Canvas
	#tag Event
		Sub LostFocus()
		  
		  MouseDown_pboo = False
		  
		  Me.Refresh
		  
		End Sub
	#tag EndEvent

	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  ' A simple 'debounce' mechanism is built into this base_button control.
		  ' Once a MouseDown event occurs, a flag is set to reject further MouseDown
		  ' events until the flag is cleared. The flag is cleared after 1/2 second. 
		  ' This is done to help eliminate unwanted MouseDown events caused by the 
		  ' operator being jostled around in their moving vehicle.
		  
		  ' Should the MouseDown event be rejected? 
		  '
		  If DebounceIsActive_pboo = True Then
		    Exit
		  End If
		  
		  ' Set flag to reject further MouseDown events.
		  '
		  DebounceIsActive_pboo = True
		  
		  ' Create a timer to clear the flag after 1/2 second.
		  '
		  Timer.CallLater(500, AddressOf Self.TimerCallLaterAction)
		  
		  
		  ' Now handle the MouseDown event.
		  
		  Me.SetFocus
		  
		  MouseDown_pboo = True
		  
		  Me.Invalidate
		  
		  ' Raise the event to our host.
		  '
		  Var Result_boo As Boolean = RaiseEvent MouseDown(X, Y)
		  
		  Return Result_boo
		  
		End Function
	#tag EndEvent

	#tag Event
		Sub MouseUp(X As Integer, Y As Integer)
		  
		  #Pragma Unused X
		  #Pragma Unused Y
		  
		  
		  MouseDown_pboo = False
		  
		  Me.Invalidate
		  
		  ' Raise the event to our host.
		  '
		  RaiseEvent MouseUp(X, Y)
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		  Me.CaptionColor = ConfigButtonCaption_gclr
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Paint(g As Graphics, areas() As REALbasic.Rect)
		  
		  #Pragma Unused areas
		  
		  Const OVER_EXTENSION = 30
		  
		  
		  ' Is button pressed? Then Hilite the button border, 
		  ' else Lolite the button border.
		  '
		  If MouseDown_pboo = True Then
		    g.DrawingColor = ConfigButtonBorderDown_gclr
		  Else
		    g.DrawingColor = ConfigButtonBorderUp_gclr
		  End If
		  
		  If Clip_pboo = False Then
		    g.FillRoundRectangle(0, 0, Me.Width, Me.Height, 16, 16)
		  Else
		    g.FillRoundRectangle(0, 0, Me.Width + OVER_EXTENSION, Me.Height, 16, 16)
		  End If
		  
		  ' Is button pressed? Then Hilite the button face, 
		  ' else Lolite the button face.
		  '
		  If MouseDown_pboo = True Then
		    g.DrawingColor = ConfigButtonFaceDown_gclr
		  Else
		    g.DrawingColor = ConfigButtonFaceUp_gclr
		  End If
		  
		  If Clip_pboo = False Then
		    g.FillRoundRectangle(2, 2, (Me.Width - 4), (Me.Height - 4), 14, 14)
		  Else
		    g.FillRoundRectangle(2, 2, (Me.Width - 4) + OVER_EXTENSION, (Me.Height - 4), 14, 14)
		  End If
		  
		  ' Set caption color.
		  '
		  g.DrawingColor = CaptionColor_pclr
		  
		  ' Set font properties.
		  '
		  g.FontName = "eurostile"
		  g.FontUnit = FontUnits.Pixel
		  g.FontSize = FontSize_pint
		  g.Bold = True
		  
		  ' Position caption.
		  '
		  If Icon_ppic <> Nil Then
		    If Caption_pstr <> "" Then
		      g.DrawText(Caption_pstr, CaptionOffset_pint, ((Me.Height - g.TextHeight) / 2) + g.FontAscent)
		    End If
		  Else
		    If Caption_pstr <> "" Then
		      g.DrawText(Caption_pstr, ((Me.Width - g.TextWidth(Caption_pstr)) / 2), ((Me.Height - g.TextHeight) / 2) + g.FontAscent)
		    End If
		  End If
		  
		  ' Position icon.
		  '
		  If Caption_pstr <> "" Then
		    If Icon_ppic <> Nil Then
		      g.DrawPicture(Icon_ppic, IconOffset_pint, (Me.Height - icon_ppic.Height) / 2)
		    End If
		  Else
		    If Icon_ppic <> Nil Then
		      g.DrawPicture(Icon_ppic, (Me.Width - icon_ppic.Width) / 2, (Me.Height - icon_ppic.Height) / 2)
		    End If
		  End If
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h21
		Private Sub TimerCallLaterAction()
		  
		  ' Now that the timer event has occurred, unset the debounce flag.
		  '
		  DebounceIsActive_pboo = False
		  
		End Sub
	#tag EndMethod


	#tag Hook, Flags = &h0
		Event MouseDown(X_int As Integer, Y_int As Integer) As Boolean
	#tag EndHook

	#tag Hook, Flags = &h0
		Event MouseUp(X_int As Integer, Y_int As Integer)
	#tag EndHook


	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return Caption_pstr
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  Caption_pstr = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		Caption As String
	#tag EndComputedProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return CaptionColor_pclr
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  CaptionColor_pclr = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		CaptionColor As Color
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private CaptionColor_pclr As Color = &cFFFFFF
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return CaptionOffset_pint
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  CaptionOffset_pint = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		CaptionOffset As Integer
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private CaptionOffset_pint As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Caption_pstr As String = "Uncaptioned"
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return Clip_pboo
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  Clip_pboo = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		Clip As Boolean
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private Clip_pboo As Boolean = False
	#tag EndProperty

	#tag Property, Flags = &h21
		Private DebounceIsActive_pboo As Boolean = False
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return FontSize_pint
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  FontSize_pint = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		FontSize As Integer
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private FontSize_pint As Integer = 22
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return Icon_ppic
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  Icon_ppic = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		Icon As Picture
	#tag EndComputedProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  
			  Return IconOffset_pint
			  
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  
			  IconOffset_pint = value
			  
			  Me.Invalidate
			  
			End Set
		#tag EndSetter
		IconOffset As Integer
	#tag EndComputedProperty

	#tag Property, Flags = &h21
		Private IconOffset_pint As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Icon_ppic As Picture = Nil
	#tag EndProperty

	#tag Property, Flags = &h21
		Private MouseDown_pboo As Boolean = False
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Width"
			Visible=true
			Group="Position"
			InitialValue="100"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Height"
			Visible=true
			Group="Position"
			InitialValue="100"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockLeft"
			Visible=true
			Group="Position"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockTop"
			Visible=true
			Group="Position"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockRight"
			Visible=true
			Group="Position"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="LockBottom"
			Visible=true
			Group="Position"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabIndex"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabStop"
			Visible=true
			Group="Position"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Caption"
			Visible=true
			Group="Appearance"
			InitialValue="Uncaptioned"
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="CaptionOffset"
			Visible=true
			Group="Appearance"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="CaptionColor"
			Visible=true
			Group="Appearance"
			InitialValue="&cFFFFFF"
			Type="Color"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="FontSize"
			Visible=true
			Group="Appearance"
			InitialValue="22"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Icon"
			Visible=true
			Group="Appearance"
			InitialValue="Nil"
			Type="Picture"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="IconOffset"
			Visible=true
			Group="Appearance"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Clip"
			Visible=true
			Group="Appearance"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="AllowAutoDeactivate"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Enabled"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="AllowFocusRing"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Visible"
			Visible=true
			Group="Appearance"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="AllowFocus"
			Visible=true
			Group="Behavior"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="AllowTabs"
			Visible=true
			Group="Behavior"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Transparent"
			Visible=true
			Group="Behavior"
			InitialValue="True"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Tooltip"
			Visible=false
			Group="Appearance"
			InitialValue=""
			Type="String"
			EditorType="MultiLineEditor"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Backdrop"
			Visible=false
			Group="Appearance"
			InitialValue=""
			Type="Picture"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="TabPanelIndex"
			Visible=false
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="DoubleBuffer"
			Visible=false
			Group="Behavior"
			InitialValue="False"
			Type="Boolean"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="InitialParent"
			Visible=false
			Group=""
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
