#tag Window
Begin Window movie_backdrop_fullscreen
   BackColor       =   &c00000000
   Backdrop        =   0
   CloseButton     =   False
   Composite       =   False
   Frame           =   4
   FullScreen      =   False
   FullScreenButton=   False
   HasBackColor    =   True
   Height          =   480
   ImplicitInstance=   False
   LiveResize      =   "True"
   MacProcID       =   0
   MaxHeight       =   480
   MaximizeButton  =   False
   MaxWidth        =   800
   MenuBar         =   0
   MenuBarVisible  =   True
   MinHeight       =   480
   MinimizeButton  =   False
   MinWidth        =   800
   Placement       =   0
   Resizeable      =   False
   Title           =   ""
   Visible         =   False
   Width           =   800
End
#tag EndWindow

#tag WindowCode
	#tag Event
		Sub Activate()
		  
		  ' Move the mouse pointer to make it go invisible.
		  '
		  MousePointerMove
		  
		  ' Now that the backdrop window is activated, activate the Movie player's
		  ' full-screen mode.
		  '
		  MoviePlayerMgr_pobj.FullScreen = True
		  
		  ' Main window hides video upon deactivation. When showing the fullscreen
		  ' video backdrop, we need to make video visible again.
		  '
		  MoviePlayerMgr_pobj.VideoIsVisible = True
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Close()
		  
		  ' Now that the backdrop window is closed, deactivate the Movie player's 
		  ' full-screen mode.
		  '
		  MoviePlayerMgr_pobj.FullScreen = False
		  
		End Sub
	#tag EndEvent

	#tag Event
		Function MouseDown(X As Integer, Y As Integer) As Boolean
		  
		  Var X_int As Integer = X
		  Var Y_int As Integer = Y
		  Var W_int As Integer = Me.Width
		  Var H_int As Integer = Me.Height
		  
		  
		  ' In what zone did the MouseDown occur?
		  '
		  Select Case GetVideoDisplayZone(X_int, Y_int, W_int, H_int)
		    
		  Case 0
		    
		    Chirp
		    Return True
		    
		  Case 6,7,8
		    
		    Chirp
		    Return True
		    
		  End Select
		  
		End Function
	#tag EndEvent

	#tag Event
		Sub MouseUp(X As Integer, Y As Integer)
		  
		  Var X_int As Integer = X
		  Var Y_int As Integer = Y
		  Var W_int As Integer = Me.Width
		  Var H_int As Integer = Me.Height
		  
		  
		  ' In what zone did the MouseUp occur?
		  '
		  Select Case GetVideoDisplayZone(X_int, Y_int, W_int, H_int)
		    
		  Case 0
		    
		    Self.Close
		    
		  Case 6,7,8
		    
		    MoviePlayerMgr_pobj.SetPosition(X * (MoviePlayerMgr_pobj.Duration / Me.Width))
		    
		  End Select
		  
		End Sub
	#tag EndEvent

	#tag Event
		Sub Open()
		  
		  ' Move the mouse pointer to make it go invisible.
		  '
		  MousePointerMove
		  
		  ' Configure main window.
		  '
		  If (Screen.ScreenAt(0).Width = 800) And (Screen.ScreenAt(0).Height = 480) Then
		    Self.FullScreen = True
		  Else
		    Self.Center
		  End If
		  Self.SetFocus
		  
		End Sub
	#tag EndEvent


	#tag Method, Flags = &h0
		Sub ShowModal(MoviePlayerMgr_obj As movie_player_mgr)
		  
		  ' Receive reference to existing Movie player object.
		  '
		  MoviePlayerMgr_pobj = MoviePlayerMgr_obj
		  
		  ' Call superclass's showmodal event.
		  '
		  Super.ShowModal
		  
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h21
		Private MoviePlayerMgr_pobj As movie_player_mgr = Nil
	#tag EndProperty


#tag EndWindowCode

#tag ViewBehavior
	#tag ViewProperty
		Name="MinimumWidth"
		Visible=true
		Group="Size"
		InitialValue="64"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MinimumHeight"
		Visible=true
		Group="Size"
		InitialValue="64"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MaximumWidth"
		Visible=true
		Group="Size"
		InitialValue="32000"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MaximumHeight"
		Visible=true
		Group="Size"
		InitialValue="32000"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Type"
		Visible=true
		Group="Frame"
		InitialValue="0"
		Type="Types"
		EditorType="Enum"
		#tag EnumValues
			"0 - Document"
			"1 - Movable Modal"
			"2 - Modal Dialog"
			"3 - Floating Window"
			"4 - Plain Box"
			"5 - Shadowed Box"
			"6 - Rounded Window"
			"7 - Global Floating Window"
			"8 - Sheet Window"
			"9 - Metal Window"
			"11 - Modeless Dialog"
		#tag EndEnumValues
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasCloseButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasMaximizeButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasMinimizeButton"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasFullScreenButton"
		Visible=true
		Group="Frame"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="DefaultLocation"
		Visible=true
		Group="Behavior"
		InitialValue="0"
		Type="Locations"
		EditorType="Enum"
		#tag EnumValues
			"0 - Default"
			"1 - Parent Window"
			"2 - Main Screen"
			"3 - Parent Window Screen"
			"4 - Stagger"
		#tag EndEnumValues
	#tag EndViewProperty
	#tag ViewProperty
		Name="HasBackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="BackgroundColor"
		Visible=true
		Group="Background"
		InitialValue="&hFFFFFF"
		Type="Color"
		EditorType="Color"
	#tag EndViewProperty
	#tag ViewProperty
		Name="Backdrop"
		Visible=true
		Group="Background"
		InitialValue=""
		Type="Picture"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Composite"
		Visible=false
		Group="OS X (Carbon)"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="FullScreen"
		Visible=false
		Group="Behavior"
		InitialValue="False"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Height"
		Visible=true
		Group="Size"
		InitialValue="400"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="ImplicitInstance"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Interfaces"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MacProcID"
		Visible=false
		Group="OS X (Carbon)"
		InitialValue="0"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MenuBar"
		Visible=true
		Group="Menus"
		InitialValue=""
		Type="MenuBar"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="MenuBarVisible"
		Visible=false
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Name"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Resizeable"
		Visible=true
		Group="Frame"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Super"
		Visible=true
		Group="ID"
		InitialValue=""
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Title"
		Visible=true
		Group="Frame"
		InitialValue="Untitled"
		Type="String"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Visible"
		Visible=true
		Group="Behavior"
		InitialValue="True"
		Type="Boolean"
		EditorType=""
	#tag EndViewProperty
	#tag ViewProperty
		Name="Width"
		Visible=true
		Group="Size"
		InitialValue="600"
		Type="Integer"
		EditorType=""
	#tag EndViewProperty
#tag EndViewBehavior
